Index: /anuga_work/development/pipeflow/test_quantity.py
===================================================================
--- /anuga_work/development/pipeflow/test_quantity.py	(revision 7822)
+++ /anuga_work/development/pipeflow/test_quantity.py	(revision 7823)
@@ -24,424 +43,563 @@
 
 
+    def test_creat_with_boundary(self):
+
+        assert self.domain4.boundary  == {(0, 0): 'left', (3, 1): 'right'}
+        
     def test_creation(self):
-        domain = Domain(self.points)
-        assert numpy.allclose(domain.centroids, [0.5, 1.5, 2.5])
-
-    def test_compute_fluxes(self):
-        """
-        Compare shallow_water_domain flux calculation against a previous
-        Python implementation (defined in this file)
-        """
-        domain = Domain(self.points)
-        domain.set_quantity('stage',2.0)
-        domain.set_boundary({'exterior' : Reflective_boundary(domain)})
-
-        stage_ud, xmom_ud = local_compute_fluxes(domain)
-
-        domain.distribute_to_vertices_and_edges()
-        domain.compute_fluxes()
-
-        print domain.quantities['stage'].explicit_update
-        print domain.quantities['xmomentum'].explicit_update
-        print stage_ud
-        print xmom_ud
-
-        assert numpy.allclose( domain.quantities['stage'].explicit_update, stage_ud )
-        assert numpy.allclose( domain.quantities['xmomentum'].explicit_update, xmom_ud )
-
-
-    def test_local_flux_function(self):
-        normal = 1.0
-        ql = numpy.array([1.0, 2.0],numpy.float)
-        qr = numpy.array([1.0, 2.0],numpy.float)
-        zl = 0.0
-        zr = 0.0
-
-        #This assumes h0 = 1.0e-3!!
-        edgeflux, maxspeed = local_flux_function(normal, ql,qr,zl,zr)
-        #print maxspeed
-        #print edgeflux
-        
-        assert numpy.allclose([2.0, 8.9], edgeflux, rtol=1.0e-005)
-        assert numpy.allclose(5.1305, maxspeed, rtol=1.0e-005)
-
-        normal = -1.0
-        ql = numpy.array([1.0, 2.0],numpy.float)
-        qr = numpy.array([1.0, 2.0],numpy.float)
-        zl = 0.0
-        zr = 0.0
-
-        edgeflux, maxspeed = local_flux_function(normal, ql,qr,zl,zr)
-
-
-        #print maxspeed
-        #print edgeflux        
-        
-        assert numpy.allclose([-2.0, -8.9], edgeflux, rtol=1.0e-005)
-        assert numpy.allclose(5.1305, maxspeed, rtol=1.0e-005)
-
-    def test_domain_flux_function(self):
-        normal = 1.0
-        ql = numpy.array([1.0, 2.0],numpy.float)
-        qr = numpy.array([1.0, 2.0],numpy.float)
-        zl = 0.0
-        zr = 0.0
-
-        edgeflux, maxspeed = local_flux_function(normal, ql,qr,zl,zr)
-
-        #print edgeflux
-
-
-
-        domainedgeflux, domainmaxspeed = domain_flux_function(normal, ql,qr,zl,zr)
-
-        #print domainedgeflux
-
-        assert numpy.allclose(domainedgeflux, edgeflux)
-        assert numpy.allclose(domainmaxspeed, maxspeed)
-
-    def test_gravity(self):
-        """
-        Compare shallow_water_domain gravity calculation
-        """
-
-        def slope_one(x):
+
+        quantity = Quantity(self.domain3)
+        assert allclose(quantity.vertex_values, [[0.0,0.0],[0.0,0.0],[0.0,0.0]])
+
+        
+        try:
+            quantity = Quantity()
+        except:
+            pass
+        else:
+            raise 'Should have raised empty quantity exception'
+
+
+        try:
+            quantity = Quantity([1,2,3])
+        except AssertionError:
+            pass
+        except:
+            raise 'Should have raised "mising domain object" error'
+
+
+    def test_creation_zeros(self):
+
+        quantity = Quantity(self.domain3)
+        assert allclose(quantity.centroid_values, [[0.,0.,0.]])
+
+
+        quantity = Quantity(self.domain4)
+        assert allclose(quantity.vertex_values, [[0.,0.], [0.,0.],
+                                                 [0.,0.], [0.,0.]])
+
+
+    def test_interpolation(self):
+        quantity = Quantity(self.domain4, self.vertex_values4)
+        assert allclose(quantity.centroid_values, self.centroid_values4) #Centroid
+
+
+
+    def test_interpolation2(self):
+        quantity = Quantity(self.domain4, self.vertex_values4)
+        assert allclose(quantity.centroid_values, self.centroid_values4) #Centroid
+
+        quantity.extrapolate_second_order()
+
+        #print quantity.vertex_values
+        assert allclose(quantity.vertex_values,[[ 0.3,  2.7],
+                                                [ 4.5,  4.5],
+                                                [ 0.5,  0.5],
+                                                [ 1.3,  7.7]])
+
+ 
+
+ 
+    def test_boundary_allocation(self):
+        quantity = Quantity(self.domain4,
+                            [[1,2], [5,5], [0,9], [-6, 3]])
+
+
+        assert quantity.boundary_values.shape[0] == len(self.domain4.boundary)
+
+
+    def test_set_values(self):
+        quantity = Quantity(self.domain4)
+
+        # Test vertices
+        quantity.set_values([[1,2], [5,5], [0,9], [-6, 3]], location = 'vertices')
+        assert allclose(quantity.vertex_values,
+                        [[1,2], [5,5], [0,9], [-6, 3]])
+        assert allclose(quantity.centroid_values, [1.5, 5., 4.5, -1.5]) #Centroid
+
+
+
+        # Test unique_vertices
+        quantity.set_values([1,2,4,-5,6], location='unique_vertices')
+        assert allclose(quantity.vertex_values,
+                        [[1,2], [2,4], [4,-5], [-5,6]])
+        assert allclose(quantity.centroid_values, [1.5, 3., -.5, .5]) #Centroid
+
+
+        # Test centroids
+        quantity.set_values([1,2,3,4], location = 'centroids')
+        assert allclose(quantity.centroid_values, [1., 2., 3., 4.]) #Centroid
+
+        # Test exceptions
+        try:
+            quantity.set_values([[1,3], [5,5], [0,9], [-6, 3]],
+                                location = 'bas kamel tuba')
+        except:
+            pass
+
+
+        try:
+            quantity.set_values([[1,3], [0,9]])
+        except AssertionError:
+            pass
+        except:
+            raise 'should have raised Assertionerror'
+
+
+
+    def test_set_values_const(self):
+        quantity = Quantity(self.domain4)
+
+        quantity.set_values(1.0, location = 'vertices')
+
+        assert allclose(quantity.vertex_values, [[1,1], [1,1], [1,1], [1, 1]])
+        assert allclose(quantity.centroid_values, [1, 1, 1, 1]) #Centroid
+
+
+        quantity.set_values(2.0, location = 'centroids')
+
+        assert allclose(quantity.centroid_values, [2, 2, 2, 2])
+
+
+    def test_set_values_func(self):
+        quantity = Quantity(self.domain4)
+
+        def f(x):
+            return x*x
+
+
+
+        quantity.set_values(f, location = 'vertices')
+
+
+        assert allclose(quantity.vertex_values,
+                        [[0,1], [1,6.25], [6.25,9], [9,25]])
+
+        assert allclose(quantity.centroid_values,
+                        [0.5, 3.625, 7.625, 34*0.5])
+
+
+        quantity.set_values(f, location = 'centroids')
+
+        
+        assert allclose(quantity.centroid_values,
+                        [0.25, 3.0625, 7.5625, 16.0])
+
+
+    def test_integral(self):
+        quantity = Quantity(self.domain4)
+
+        #Try constants first
+        const = 5
+        quantity.set_values(const, location = 'vertices')
+        #print 'Q', quantity.get_integral()
+
+        assert allclose(quantity.get_integral(), self.domain4.get_area() * const)
+
+        #Try with a linear function
+        def f(x):
             return x
 
-        domain = Domain(self.points)
-        domain.set_quantity('stage',4.0)
-        domain.set_quantity('elevation',slope_one)
-        domain.set_boundary({'exterior' : Reflective_boundary(domain)})
-
-        gravity(domain)
-        
-        #print domain.quantities['stage'].vertex_values 
-        #print domain.quantities['elevation'].vertex_values 
-        #print domain.quantities['xmomentum'].explicit_update       
-
-        assert numpy.allclose( [-34.3, -24.5, -14.7], domain.quantities['xmomentum'].explicit_update )
-
-
-    def xtest_evolve_first_order(self):
-        """
-        Compare still lake solution for various versions of shallow_water_domain
-        """
-        
-        def slope_square(x):
-            return numpy.maximum(4.0-(x-5.0)*(x-5.0), 0.0)
-
-        domain = Domain(self.points2)
-        domain.set_quantity('stage',10.0)
-        domain.set_quantity('elevation',slope_square)
-        domain.set_boundary({'exterior' : Reflective_boundary(domain)})
-
-        domain.default_order = 1
-        domain.set_timestepping_method('euler')
-        
-        yieldstep=1.0
-        finaltime=1.0
-
-        for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
-            #pass
-        
-            print domain.quantities['stage'].vertex_values
-            print domain.quantities['elevation'].vertex_values
-            print domain.quantities['xmomentum'].vertex_values
-          
-        
-            print domain.quantities['stage'].centroid_values  
-            print domain.quantities['elevation'].centroid_values
-            print domain.quantities['xmomentum'].centroid_values    
-
-        assert numpy.allclose( 10.0*numpy.ones(10), domain.quantities['stage'].centroid_values )
-        assert numpy.allclose( numpy.zeros(10), domain.quantities['xmomentum'].centroid_values )
-
-
-    def xtest_evolve_euler_second_order_space(self):
-        """
-        Compare still lake solution for various versions of shallow_water_domain
-        """
-
-        def slope_square(x):
-            return numpy.maximum(4.0-(x-5.0)*(x-5.0), 0.0)
-
-        domain = Domain(self.points2)
-        domain.set_quantity('stage',10.0)
-        domain.set_quantity('elevation',slope_square)
-        domain.set_boundary({'exterior' : Reflective_boundary(domain)})
-
-        domain.default_order = 2
-        domain.set_timestepping_method('rk2')
-        yieldstep=1.0
-        finaltime=1.0
-
-        for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
-            pass
-        
-        assert numpy.allclose( 10.0*ones(10), domain.quantities['stage'].centroid_values )
-        assert numpy.allclose( zeros(10), domain.quantities['xmomentum'].centroid_values )
-
-    def xtest_evolve_second_order_space_time(self):
-        """
-        Compare still lake solution for various versions of shallow_water_domain
-        """
-
-        def slope_square(x):
-            return numpy.maximum(4.0-(x-5.0)*(x-5.0), 0.0)
-
-        domain = Domain(self.points2)
-        domain.set_quantity('stage',10.0)
-        domain.set_quantity('elevation',slope_square)
-        domain.set_boundary({'exterior' : Reflective_boundary(domain)})
-
-        domain.default_order = 2
-        domain.set_timestepping_method('rk3')
-
-        yieldstep=1.0
-        finaltime=1.0
-
-        for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
-            pass
-        
-        assert numpy.allclose( 10.0*ones(10), domain.quantities['stage'].centroid_values )
-        assert numpy.allclose( zeros(10), domain.quantities['xmomentum'].centroid_values )
-
-
-
-#==============================================================================
-
-def local_compute_fluxes(domain):
-    """Compute all fluxes and the timestep suitable for all volumes
-    in domain.
-
-    Compute total flux for each conserved quantity using "flux_function"
-
-    Fluxes across each edge are scaled by edgelengths and summed up
-    Resulting flux is then scaled by area and stored in
-    explicit_update for each of the three conserved quantities
-    stage, xmomentum and ymomentum
-
-    The maximal allowable speed computed by the flux_function for each volume
-    is converted to a timestep that must not be exceeded. The minimum of
-    those is computed as the next overall timestep.
-
-    Post conditions:
-      domain.explicit_update is reset to computed flux values
-      domain.timestep is set to the largest step satisfying all volumes.
-    """
-
-    import sys
-    from Numeric import zeros, Float
-
-    N = domain.number_of_elements
-
-    tmp0 = zeros(N,Float)
-    tmp1 = zeros(N,Float)
-
-    #Shortcuts
-    Stage = domain.quantities['stage']
-    Xmom = domain.quantities['xmomentum']
-    #    Ymom = domain.quantities['ymomentum']
-    Bed = domain.quantities['elevation']
-
-    #Arrays
-    #stage = Stage.edge_values
-    #xmom =  Xmom.edge_values
-    #   ymom =  Ymom.edge_values
-    #bed =   Bed.edge_values
-    
-    stage = Stage.vertex_values
-    xmom =  Xmom.vertex_values
-    bed =   Bed.vertex_values
-    
-    #print 'stage edge values', stage
-    #print 'xmom edge values', xmom
-    #print 'bed values', bed
-
-    stage_bdry = Stage.boundary_values
-    xmom_bdry =  Xmom.boundary_values
-    #print 'stage_bdry',stage_bdry
-    #print 'xmom_bdry', xmom_bdry
-    #    ymom_bdry =  Ymom.boundary_values
-
-    #    flux = zeros(3, Float) #Work numpy.array for summing up fluxes
-    flux = zeros(2, Float) #Work numpy.array for summing up fluxes
-    ql = zeros(2, Float)
-    qr = zeros(2, Float)
-
-    #Loop
-    timestep = float(sys.maxint)
-    enter = True
-    for k in range(N):
-
-        flux[:] = 0.  #Reset work numpy.array
-        #for i in range(3):
-        for i in range(2):
-            #Quantities inside volume facing neighbour i
-            #ql[0] = stage[k, i]
-            #ql[1] = xmom[k, i]
-            ql = [stage[k, i], xmom[k, i]]
-            zl = bed[k, i]
-
-            #Quantities at neighbour on nearest face
-            n = domain.neighbours[k,i]
-            if n < 0:
-                m = -n-1 #Convert negative flag to index
-                qr[0] = stage_bdry[m]
-                qr[1] = xmom_bdry[m]
-                zr = zl #Extend bed elevation to boundary
-            else:
-                #m = domain.neighbour_edges[k,i]
-                m = domain.neighbour_vertices[k,i]
-                #print i, ' ' , m
-                #qr = [stage[n, m], xmom[n, m], ymom[n, m]]
-                qr[0] = stage[n, m]
-                qr[1] = xmom[n, m]
-                zr = bed[n, m]
-
-
-            #Outward pointing normal vector
-            normal = domain.normals[k, i]
-        
-            #Flux computation using provided function
-            #edgeflux, max_speed = flux_function(normal, ql, qr, zl, zr)
-            #print 'ql',ql
-            #print 'qr',qr
-            
-
-            edgeflux, max_speed = flux_function(normal, ql, qr, zl, zr)
-
-            #print 'edgeflux', edgeflux
-
-            # THIS IS THE LINE TO DEAL WITH LEFT AND RIGHT FLUXES
-            # flux = edgefluxleft - edgefluxright
-            flux -= edgeflux #* domain.edgelengths[k,i]
-            #Update optimal_timestep
-            try:
-                #timestep = min(timestep, 0.5*domain.radii[k]/max_speed)
-                timestep = min(timestep, domain.CFL*0.5*domain.areas[k]/max_speed)
-            except ZeroDivisionError:
-                pass
-
-        #Normalise by area and store for when all conserved
-        #quantities get updated
-        flux /= domain.areas[k]
-
-        #Stage.explicit_update[k] = flux[0]
-        tmp0[k] = flux[0]
-        tmp1[k] = flux[1]
-
-
-    return tmp0, tmp1
-
-
-def local_flux_function(normal, ql, qr, zl, zr):
-    """Compute fluxes between volumes for the shallow water wave equation
-    cast in terms of w = h+z using the 'central scheme' as described in
-
-    Kurganov, Noelle, Petrova. 'Semidiscrete Central-Upwind Schemes For
-    Hyperbolic Conservation Laws and Hamilton-Jacobi Equations'.
-    Siam J. Sci. Comput. Vol. 23, No. 3, pp. 707-740.
-
-    The implemented formula is given in equation (3.15) on page 714
-
-    Conserved quantities w, uh, are stored as elements 0 and 1
-    in the numerical vectors ql an qr.
-
-    Bed elevations zl and zr.
-    """
-
-    from config import g, epsilon, h0
-    from math import sqrt
-
-
-    #print 'ql',ql
-
-    #Align momentums with x-axis
-    #q_left  = rotate(ql, normal, direction = 1)
-    #q_right = rotate(qr, normal, direction = 1)
-    q_left = ql
-    q_left[1] = q_left[1]*normal
-    q_right = qr
-    q_right[1] = q_right[1]*normal
-
-    #z = (zl+zr)/2 #Take average of field values
-    z = 0.5*(zl+zr) #Take average of field values
-
-    w_left  = q_left[0]   #w=h+z
-    h_left  = w_left-z
-    uh_left = q_left[1]
-
-    if h_left < epsilon:
-        u_left = 0.0  #Could have been negative
-        h_left = 0.0
-    else:
-        u_left  = uh_left/(h_left +  h0/h_left)
-
-
-    uh_left = u_left*h_left
-
-    w_right  = q_right[0]  #w=h+z
-    h_right  = w_right-z
-    uh_right = q_right[1]
-
-
-    if h_right < epsilon:
-        u_right = 0.0  #Could have been negative
-        h_right = 0.0
-    else:
-        u_right  = uh_right/(h_right + h0/h_right)
-
-    uh_right = u_right*h_right
-    
-    #vh_left  = q_left[2]
-    #vh_right = q_right[2]
-
-    #print h_right
-    #print u_right
-    #print h_left
-    #print u_right
-
-    soundspeed_left  = sqrt(g*h_left)
-    soundspeed_right = sqrt(g*h_right)
-
-    #Maximal wave speed
-    s_max = max(u_left+soundspeed_left, u_right+soundspeed_right, 0)
-    
-    #Minimal wave speed
-    s_min = min(u_left-soundspeed_left, u_right-soundspeed_right, 0)
-    
-    #Flux computation
-
-    #flux_left  = numpy.array([u_left*h_left,
-    #                    u_left*uh_left + 0.5*g*h_left**2])
-    #flux_right = numpy.array([u_right*h_right,
-    #                    u_right*uh_right + 0.5*g*h_right**2])
-    flux_left  = numpy.array([u_left*h_left,
-                        u_left*uh_left + 0.5*g*h_left*h_left])
-    flux_right = numpy.array([u_right*h_right,
-                        u_right*uh_right + 0.5*g*h_right*h_right])
-
-    denom = s_max-s_min
-    if denom == 0.0:
-        edgeflux = numpy.array([0.0, 0.0])
-        max_speed = 0.0
-    else:
-        edgeflux = (s_max*flux_left - s_min*flux_right)/denom
-        edgeflux += s_max*s_min*(q_right-q_left)/denom
-        
-        edgeflux[1] = edgeflux[1]*normal
-
-        max_speed = max(abs(s_max), abs(s_min))
-
-    return edgeflux, max_speed
-
-
+        quantity.set_values(f, location = 'vertices')
+
+ 
+        assert allclose (quantity.centroid_values,
+        [ 0.5,   1.75,  2.75,  4.  ])
+
+        assert allclose (quantity.vertex_values, [[ 0.,   1. ],
+                                                  [ 1.,   2.5],
+                                                  [ 2.5,  3. ],
+                                                  [ 3.,   5. ]])
+
+
+        ref_integral = 0.5 + 1.5*1.75 + 0.5*2.75 + 2.0*4.0
+
+        assert allclose (quantity.get_integral(), ref_integral)
+
+
+
+
+
+    def test_set_values_from_quantity(self):
+
+        quantity1 = Quantity(self.domain4)
+        quantity1.set_values([0,1,2,3,4], location='unique_vertices')
+
+        assert allclose(quantity1.vertex_values,
+                        [[0,1], [1,2], [2,3], [3,4]])
+
+
+        quantity2 = Quantity(self.domain4)
+        quantity2.set_values(quantity1)
+        assert allclose(quantity2.vertex_values,
+                        [[0,1], [1,2], [2,3], [3,4]])
+
+        quantity2.set_values(2*quantity1)
+
+        assert allclose(quantity2.vertex_values,
+                        [[0,2], [2,4], [4,6], [6,8]])
+
+        quantity2.set_values(2*quantity1 + 3)
+        assert allclose(quantity2.vertex_values,
+                        [[3,5], [5,7], [7,9], [9,11]])
+
+
+
+    def test_overloading(self):
+
+        quantity1 = Quantity(self.domain4)
+        quantity1.set_values( [[0,1],[1,2],[2,3],[3,4]],
+                            location = 'vertices')
+
+        assert allclose(quantity1.vertex_values,
+                        [[0,1], [1,2], [2,3], [3,4]])
+
+
+        quantity2 = Quantity(self.domain4)
+        quantity2.set_values([[1,2], [5,5], [0,9], [-6, 3]],
+                             location = 'vertices')
+
+
+
+        quantity3 = Quantity(self.domain4)
+        quantity3.set_values([[2,2], [7,8], [7,6], [3, -8]],
+                             location = 'vertices')
+
+
+        # Negation
+        Q = -quantity1
+        assert allclose(Q.vertex_values, -quantity1.vertex_values)
+        assert allclose(Q.centroid_values, -quantity1.centroid_values)
+
+
+        # Addition
+        Q = quantity1 + 7
+        assert allclose(Q.vertex_values, quantity1.vertex_values + 7)
+        assert allclose(Q.centroid_values, quantity1.centroid_values + 7)
+
+        Q = 7 + quantity1
+        assert allclose(Q.vertex_values, quantity1.vertex_values + 7)
+        assert allclose(Q.centroid_values, quantity1.centroid_values + 7)
+
+        Q = quantity1 + quantity2
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values + quantity2.vertex_values)
+        assert allclose(Q.centroid_values,
+                        quantity1.centroid_values + quantity2.centroid_values)
+
+        Q = quantity1 + quantity2 - 3
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values + quantity2.vertex_values - 3)
+
+        Q = quantity1 - quantity2
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values - quantity2.vertex_values)
+
+        #Scaling
+        Q = quantity1*3
+        assert allclose(Q.vertex_values, quantity1.vertex_values*3)
+        assert allclose(Q.centroid_values, quantity1.centroid_values*3)
+
+        Q = 3*quantity1
+        assert allclose(Q.vertex_values, quantity1.vertex_values*3)
+
+        #Multiplication
+        Q = quantity1 * quantity2
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values * quantity2.vertex_values)
+
+        #Linear combinations
+        Q = 4*quantity1 + 2
+        assert allclose(Q.vertex_values,
+                        4*quantity1.vertex_values + 2)
+
+        Q = quantity1*quantity2 + 2
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values * quantity2.vertex_values + 2)
+
+        Q = quantity1*quantity2 + quantity3
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values * quantity2.vertex_values +
+                        quantity3.vertex_values)
+        Q = quantity1*quantity2 + 3*quantity3
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values * quantity2.vertex_values +
+                        3*quantity3.vertex_values)
+        Q = quantity1*quantity2 + 3*quantity3 + 5.0
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values * quantity2.vertex_values +
+                        3*quantity3.vertex_values + 5)
+
+        Q = quantity1*quantity2 - quantity3
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values * quantity2.vertex_values -
+                        quantity3.vertex_values)
+        Q = 1.5*quantity1*quantity2 - 3*quantity3 + 5.0
+        assert allclose(Q.vertex_values,
+                        1.5*quantity1.vertex_values * quantity2.vertex_values -
+                        3*quantity3.vertex_values + 5)
+
+        #Try combining quantities and arrays and scalars
+        Q = 1.5*quantity1*quantity2.vertex_values -\
+            3*quantity3.vertex_values + 5.0
+        assert allclose(Q.vertex_values,
+                        1.5*quantity1.vertex_values * quantity2.vertex_values -
+                        3*quantity3.vertex_values + 5)
+
+
+        #Powers
+        Q = quantity1**2
+        assert allclose(Q.vertex_values, quantity1.vertex_values**2)
+
+        Q = quantity1**2 +quantity2**2
+        assert allclose(Q.vertex_values,
+                        quantity1.vertex_values**2 + \
+                        quantity2.vertex_values**2)
+
+        Q = (quantity1**2 +quantity2**2)**0.5
+        assert allclose(Q.vertex_values,
+                        (quantity1.vertex_values**2 + \
+                        quantity2.vertex_values**2)**0.5)
+
+    def test_compute_gradient(self):
+        quantity = Quantity(self.domain6)
+
+        #Set up for a gradient of (2,0) at mid triangle
+        quantity.set_values([2.0, 4.0, 4.0, 5.0, 10.0, 12.0],
+                            location = 'centroids')
+
+
+        #Gradients
+        quantity.compute_gradients()
+
+        a = quantity.gradients
+
+        assert allclose(a, [ 3., 1., 0.5, 3., 3.5, 0.5])
+        
+        quantity.extrapolate_second_order()
+
+
+        assert allclose(quantity.vertex_values, [[ 1., 3. ],
+                                                 [ 4., 4. ],
+                                                 [ 4., 4. ],
+                                                 [ 4., 6.],
+                                                 [ 8.25, 11.75],
+                                                 [ 11.,  13. ]])
+
+                                                 
+
+    def test_second_order_extrapolation2(self):
+        quantity = Quantity(self.domain4)
+
+        #Set up for a gradient of (3,1), f(x) = 3x+y
+        quantity.set_values([2.0+2.0/3, 4.0+4.0/3, 8.0+2.0/3, 2.0+8.0/3],
+                            location = 'centroids')
+
+        #Gradients
+        quantity.compute_gradients()
+
+        a = quantity.gradients
+        
+
+        assert allclose(a[1], 2.8)
+
+        #Work out the others
+
+        quantity.extrapolate_second_order()
+        
+
+        assert allclose(quantity.vertex_values[1,0], 3.33333333)
+        assert allclose(quantity.vertex_values[1,1], 7.33333333)
+
+        assert allclose(quantity.centroid_values[1], 0.5*(7.33333333+3.33333333) )
+
+
+
+
+    def test_backup_saxpy_centroid_values(self):
+        quantity = Quantity(self.domain4)
+
+        #Set up for a gradient of (3,1), f(x) = 3x+y
+        c_values = array([2.0+2.0/3, 4.0+4.0/3, 8.0+2.0/3, 2.0+8.0/3])
+        d_values = array([1.0, 2.0, 3.0, 4.0])
+        quantity.set_values(c_values, location = 'centroids')
+
+        #Backup
+        quantity.backup_centroid_values()
+
+        #print quantity.vertex_values
+        assert allclose(quantity.centroid_values, quantity.centroid_backup_values)
+
+
+        quantity.set_values(d_values, location = 'centroids')
+
+        quantity.saxpy_centroid_values(2.0, 3.0)
+
+        assert allclose(quantity.centroid_values, 2.0*d_values + 3.0*c_values)
+
+
+
+    def test_first_order_extrapolator(self):
+        quantity = Quantity(self.domain4)
+
+        centroid_values = array([1.,2.,3.,4.])
+        quantity.set_values(centroid_values, location = 'centroids')
+        assert allclose(quantity.centroid_values, centroid_values) #Centroid
+
+        #Extrapolate
+        quantity.extrapolate_first_order()
+
+        #Check that gradient is zero
+        a = quantity.gradients
+        assert allclose(a, [0,0,0,0])
+       
+
+        #Check vertices but not edge values
+        assert allclose(quantity.vertex_values,
+                        [[1,1], [2,2], [3,3], [4,4]])
+
+
+    def test_second_order_extrapolator(self):
+        quantity = Quantity(self.domain4)
+
+        #Set up for a gradient of (3,0) at mid triangle
+        quantity.set_values([2.0, 4.0, 8.0, 2.0],
+                            location = 'centroids')
+
+
+
+        quantity.extrapolate_second_order()
+
+
+        #Assert that quantities are conserved
+        from Numeric import sum
+        for k in range(quantity.centroid_values.shape[0]):
+            assert allclose (quantity.centroid_values[k],
+                             sum(quantity.vertex_values[k,:])/2.0)
+
+
+    def test_limit(self):
+        quantity = Quantity(self.domain4)
+
+        #Create a deliberate overshoot (e.g. from gradient computation)
+        quantity.set_values([[0,0], [2,20], [-20,3], [8,3]])
+
+        #Limit
+        quantity.limit_minmod()
+
+       
+        #cells 1 and 2 are local max and min
+        assert quantity.vertex_values[1][0] == quantity.centroid_values[1]
+        assert quantity.vertex_values[1][1] == quantity.centroid_values[1]
+
+        assert quantity.vertex_values[2][0] == quantity.centroid_values[2]
+        assert quantity.vertex_values[2][1] == quantity.centroid_values[2]
+
+
+
+    def test_distribute_first_order(self):
+        quantity = Quantity(self.domain4)
+
+        #Test centroids
+        centroid_values = array([1.,2.,3.,4.])
+        quantity.set_values(centroid_values, location = 'centroids')
+        assert allclose(quantity.centroid_values, centroid_values) #Centroid
+
+
+        #Extrapolate from centroid to vertices and edges
+        quantity.extrapolate_first_order()
+        
+        assert allclose(quantity.vertex_values,[[ 1.,  1.],
+                                                [ 2.,  2.],
+                                                [ 3.,  3.],
+                                                [ 4.,  4.]])
+ 
+
+
+    def test_distribute_second_order(self):
+        quantity = Quantity(self.domain4)
+
+        #Test centroids
+        centroid_values = array([2.,4.,8.,2.])
+        quantity.set_values(centroid_values, location = 'centroids')
+        assert allclose(quantity.centroid_values, centroid_values) #Centroid
+
+
+        #Extrapolate
+        quantity.extrapolate_second_order()
+
+        assert allclose(quantity.vertex_values, [[ 1.2,  2.8],
+                                                 [ 2.,  6. ],
+                                                 [ 8.,   8. ],
+                                                 [ 6.8, -2.8]])
+
+
+    def test_update_explicit(self):
+        quantity = Quantity(self.domain4)
+
+        #Test centroids
+        quantity.set_values([1.,2.,3.,4.], location = 'centroids')
+        assert allclose(quantity.centroid_values, [1, 2, 3, 4]) #Centroid
+
+        #Set explicit_update
+        quantity.explicit_update = array( [1.,1.,1.,1.] )
+
+        #Update with given timestep
+        quantity.update(0.1)
+
+        x = array([1, 2, 3, 4]) + array( [.1,.1,.1,.1] )
+        assert allclose( quantity.centroid_values, x)
+
+    def test_update_semi_implicit(self):
+        quantity = Quantity(self.domain4)
+
+        #Test centroids
+        quantity.set_values([1.,2.,3.,4.], location = 'centroids')
+        assert allclose(quantity.centroid_values, [1, 2, 3, 4]) #Centroid
+
+        #Set semi implicit update
+        quantity.semi_implicit_update = array([1.,1.,1.,1.])
+
+        #Update with given timestep
+        timestep = 0.1
+        quantity.update(timestep)
+
+        sem = array([1.,1.,1.,1.])
+        denom = ones(4, numpy.float)-timestep*sem
+
+        x = array([1, 2, 3, 4])/denom
+        assert allclose( quantity.centroid_values, x)
+
+
+    def test_both_updates(self):
+        quantity = Quantity(self.domain4)
+
+        #Test centroids
+        centroid_values = array( [1, 2, 3, 4] )
+        quantity.set_values(centroid_values, location = 'centroids')
+        assert allclose(quantity.centroid_values, centroid_values) #Centroid
+
+        #Set explicit_update
+        explicit_update = array( [4.,3.,2.,1.] )
+        quantity.explicit_update[:,] = explicit_update
+
+        #Set semi implicit update
+        semi_implicit_update = array( [1.,1.,1.,1.] )
+        quantity.semi_implicit_update[:,] = semi_implicit_update
+
+        #Update with given timestep
+        timestep = 0.1
+        quantity.update(0.1)
+
+        denom = 1.0-timestep*semi_implicit_update
+        x = (centroid_values + timestep*explicit_update)/denom
+ 
+        assert allclose( quantity.centroid_values, x)
+
+
+ 
 #-------------------------------------------------------------
 if __name__ == "__main__":
-    suite = unittest.makeSuite(Test_Shallow_Water, 'test')
-    #suite = unittest.makeSuite(Test_Shallow_Water, 'test_evolve_first_order')
-
-
+    suite = unittest.makeSuite(Test_Quantity, 'test')
     runner = unittest.TextTestRunner()
     runner.run(suite)
